#include <compat/twi.h>

#define I2C_WRITE_MODE 0
#define I2C_READ_MODE 1
#define I2C_READ_WITH_NACK 0
#define I2C_READ_WITH_ACK 1

#define SET_TWCR(x)   {TWCR=(x)|_BV(TWINT)|_BV(TWEN);}while(0)
#define TWI_START SET_TWCR(_BV(TWSTA))
#define TWI_ACK   SET_TWCR(_BV(TWEA))
#define TWI_NACK  SET_TWCR(0)
#define TWI_NEXT  SET_TWCR(0)
#define TWI_STOP  SET_TWCR(_BV(TWSTO))
#define TWI_END   SET_TWCR(0)
#define WAIT_TWINT     loop_until_bit_is_set(TWCR,TWINT)
#define F_SCL (100000L)	/*100kHz*/
#define TWBR_VALUE ((F_CPU/F_SCL-16)/2)

#define TWI_RATE_20K 0x00
#define TWI_RATE_50K 0x01
#define TWI_RATE_100K 0x02
#define TWI_RATE_400K 0x03
#define TWI_RATE_700K 0x04


void i2c_master_init(void);
int i2c_start(int address, int rw);
void i2c_write(int data);
int i2c_read(int ack_mode);
void i2c_stop();

void twi_init(unsigned char twi_rate);
uint8_t TWI_wait(void);
uint8_t TWI_start(void);
uint8_t TWI_stop(void);
uint8_t TWI_write(uint8_t x);
uint8_t TWI_read(char ack);
char sla_set(uint8_t sla_rw);

